//89ac62fbf8d3f43ce1bc304e4e3842e9  libbnSQL-ExcelRead1.0.cpp.new
//2f87cb4720e2bc6beff23919e98e05b1  libbnSQL-ExcelRead1.0.cpp
//2do sprintf ( _SQLQuery, "select * from Customer" );
extern "C" {
//#define DEBUG
//#define ACTION
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <locale.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>
#include "bnSQL.h"

#include "DEFExcelRead.h"
//after bnSQL.h !!!!, else tb-db = 0 @ tbOpen
//#include <errno.h>
#include <xls.h>


_bnColumn		*coInsertX		( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );
_bnColumn *ExcelRead1_0_tbColumnInsert	( _bnTable *tb );


char *ExcelRead1_0_dbOpen ( _bnDataBase *db ) {
PFLID
char *Error = db->Error;

//error check
    if ( ! db		) return NULL;

    if ( Error[0] 	) return Error;
    if ( db->Conn	) return Error;	//already open

#ifdef ACTION
    printf ( "%s"	, (char *)__PRETTY_FUNCTION__ );
    printf ( "	%s"	, (char *)__FILE__ );
    printf ( "	%s"	, db->Base );
    printf ( "@%s"	, db->Host );
    printf ( "\n" );
#endif

char	MyFile[255];
    sprintf ( MyFile, "%s/%s", db->Host, db->Base );

//    xlsWorkBook *pWB = xls_open ( MyFile, (char *)db->encoding );//2do
    xlsWorkBook *pWB = xls_open ( MyFile, (char *)"utf8" );//2do
    //xls_getVersion();
    if ( ! pWB ) SER  ( "! pWB"			);

    db->Conn = (xlsWorkBook *)pWB;

    return Error;

}//


char *ExcelRead1_0_dbClose ( _bnDataBase *db ) {
PFLID

//error check
    if ( ! db		) return NULL;

char *Error = db->Error;

    if ( ! db->Conn	) return Error;	//already closed

#ifdef ACTION
    printf ( "%s"	, (char *)__PRETTY_FUNCTION__ );
    printf ( "	%s"	, (char *)__FILE__ );
    printf ( "	%s"	, db->Base );
    printf ( "@%s"	, db->Host );
    printf ( "\n" );
#endif

    free ( db->Conn );
    db->Conn = NULL;

    return Error;

}//char	*dbClose ( _bnDataBase *db )


char *ExcelRead1_0_tbOpen		( _bnTable *tb ) {
PFLID

//error check
    if ( ! tb		) return NULL;

char *Error = tb->Error;

    if ( Error[0] 	) return Error;
    if ( tb->Result	) return Error;	//alreay open
    if ( ! tb->db	) SER ( "! tb->db"		);
    if ( ! tb->db->Conn	) SER ( "! tb->db->Conn"	);

#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__	);
    printf ( "	%s"		, tb->Name		);
    printf ( "\n" );
    //printf ( "Col=~%c~	Row=0x%02X\n", TB->Col, TB->Row	);
    //printf ( "SQL=~%s~\n"		, tb->SQLQuery		);
#endif

xlsWorkBook	*pWB = (xlsWorkBook *)tb->db->Conn;

    if ( strcmp ( tb->SQLQuery, "select name from systables" ) == 0 ) {
	//for ( int i = 0 ; i < pWB->sheets.count ; i++ ) printf ("Sheet N%i (~%s~) pos %i\n",i,pWB->sheets.sheet[i].name,pWB->sheets.sheet[i].filepos);

    //amount of Records
	tb->Records	= pWB->sheets.count;
    //amount of Fields
	tb->Fields	= 1;
    //all OK
	tb->Result	= tb;
	return Error;

    }//if ( strcmp ( tb->SQLQuery, "select name from systables" ) == 0 )

long	WSOpen = 0;
    for ( int i = 0 ; i < pWB->sheets.count ; i++ ) {
	if ( strcmp ( (char *)pWB->sheets.sheet[i].name, tb->Name ) == 0 ) WSOpen = i + 1;
	if ( WSOpen ) break;
    }//for ( int i = 0 ; i < pWB->sheets.count ; i++ )
    if ( ! WSOpen ) SER2 ( "Table %s not Found", tb->Name );

xlsWorkSheet	*pWS = xls_getWorkSheet ( pWB, WSOpen - 1 );
    if ( ! pWS ) SER  ( "! pWS"			);
    xls_parseWorkSheet ( pWS );

#ifdef DEBUG_DATA
    printf ( "<style type=\"text/css\">\n%s</style>\n",xls_getCSS ( pWB ) );
    printf ( "<table border=0 cellspacing=0 cellpadding=2>\n" );
#endif

//amount of Records
    tb->Records	= pWS->rows.lastrow + 1;

    if ( tb->FirstRowFieldNames ) {
	if ( 1 <= tb->Records ) {
	    tb->Records -= 1;
	}
    }

//amount of Fields
    tb->Fields  = pWS->rows.lastcol;
//all OK
    tb->Result = (xlsWorkSheet	*)pWS;

//ColumnsQuery
    for ( tb->ColumnInsertFokus = 0; tb->ColumnInsertFokus < tb->Fields ; tb->ColumnInsertFokus++ ) {
	//printf ( "tb->ColumnInsertFokus=%ld\n", tb->ColumnInsertFokus );
    _bnColumn *coIns = (_bnColumn *)ExcelRead1_0_tbColumnInsert(tb);
	if ( ! coIns ) continue;
	//printf ( "coIns->Name=%s\n", coIns->Name );
	tb->ColumnsQuery.Insert ( coIns->Name, coIns->Type, coIns->Size );
    }//for ( tb->ColumnInsertFokus = 0; tb->ColumnInsertFokus < tb->Fields ; tb->ColumnInsertFokus++ )
    tb->ColumnInsertFokus = 0;//2do @ bnSQLTable....

    return Error;

}//char	*tbOpen		( _bnTable *tb )


_bnColumn *ExcelRead1_0_tbColumnInsert	( _bnTable *tb ) {
PFLID

char	*myName = new char[20];
    if ( strcmp ( tb->SQLQuery, "select name from systables" ) == 0 )
	sprintf ( myName, "name" );
    else
	sprintf ( myName, "A%05ld", tb->ColumnInsertFokus );

    //printf ( "tb->ColumnInsertFokus=%ld tb->FirstRowFieldNames=%ld myName=%s \n", tb->ColumnInsertFokus, tb->FirstRowFieldNames, myName );
    if ( tb->FirstRowFieldNames ) {
	if ( tb ) {
	    if ( tb->Result ) {
	    xlsWorkSheet               *pWS = (xlsWorkSheet *)tb->Result;
	    struct st_row::st_row_data *row = &pWS->rows.row[ 0 ];
	    char *xlsRowName = row->cells.cell[ tb->ColumnInsertFokus ].str;
		if ( xlsRowName ) {
		    if ( xlsRowName[0] ) {
			//printf ( "rowcol=%s\n", xlsRowName );
			sprintf ( myName, "%s", xlsRowName );
		    }
		}//if ( xlsRowName )
	    }//if ( tb->Result )
	}//if ( tb )
    }//if ( tb->FirstRowFieldNames )

long	 myType = 100;
long	 mySize = 255;
long	 myFlags = 0;

//Flags Mapping
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_PRI_KEY;
    //if ( strcmp ( myName, "ID" ) == 0 ) myFlags += bnCO_AUTO_INCREMENT;

    return coInsertX ( tb, (_DEF2COL *)&ExcelRead2DEF, myName, myType, mySize, myFlags );

}//_bnColumn	*tbColumnInsert	( _bnTable *tb )


char *ExcelRead1_0_tbClose	( _bnTable *tb ) {
PFLID

//error check
    if ( ! tb		) return NULL;

char *Error = tb->Error;

    if ( Error[0] 	) return Error;
    if ( ! tb->Result	) return Error;	//not open

#ifdef ACTION
    printf ( "%s"	, (char *)__PRETTY_FUNCTION__	);
    printf ( "	%s"	, (char *)__FILE__		);
    printf ( "	%s"	, tb->Name			);
    printf ( "\n" );
#endif

//all OK
    //2do glibc double free or corruption ... free ( tb->Result );	//delete tb->Result;
    tb->Result	= NULL;
    tb->Records	= 0;
    tb->Fields	= 0;
    tb->Error[0]= 0;
    tb->Fokus	= 0;

    return tb->Error;

}//char	*tbClose	( _bnTable *tb )


char *ExcelRead1_0_tbColumn	( _bnTable *tb ) {
PFLID

//error check
    if ( ! tb		) return NULL;

char *Error = tb->Error;

    if ( Error[0] 	) return NULL;
    if ( ! tb->Records	) return NULL;
    if ( ! tb->Result	) sprintf ( Error, "%s @ %s[%d]\n", "! tb->Result", __PRETTY_FUNCTION__, __LINE__ );
    if ( Error[0]	) return NULL;

    if ( tb->FirstRowFieldNames ) tb->FirstRowFieldNames = 1;

//select name from systables
    if ( tb->Result	== tb ) {
    //error check
	if ( ! tb->db->Conn ) sprintf ( Error, "%s @ %s[%d]\n", "! tb->db->Conn", __PRETTY_FUNCTION__, __LINE__ );
	if ( Error[0]	) return NULL;

    xlsWorkBook *pWB = (xlsWorkBook *)tb->db->Conn;
	return (char *)pWB->sheets.sheet[ tb->Fokus - 1 ].name;

    }//if ( tb->Result	== tb )
//select name from systables done

xlsWorkSheet               *pWS = (xlsWorkSheet *)tb->Result;
xlsWorkBook                *pWB = (xlsWorkBook  *)tb->db->Conn;
struct st_row::st_row_data *row = &pWS->rows.row[ tb->Fokus - 1 + tb->FirstRowFieldNames ];
static char myRet[2500];

long loop = 0;
    while ( _bnColumn	*myCol = tb->ColumnsQuery[loop++] ) {
	//printf ( "tb->FetchColumn->Name=%s, myCol->Name=%s myCol->Type=%s\n", tb->FetchColumn->Name, myCol->Name, myCol->Type );
	if ( strcmp ( tb->FetchColumn->Name, myCol->Name ) == 0 ) {
	    myRet[0] = 0;

	long cell_xf = row->cells.cell[loop - 1].xf;
#ifdef DEBUG
	    sprintf ( myRet, "Name=%s|", myCol->Name );
	    sprintf ( myRet, "%s|cell_id=0x%03X",myRet, row->cells.cell[loop - 1].id );
	    sprintf ( myRet, "%s|cell_xf=%ld",myRet, cell_xf );
	    long xfs_count = pWB->xfs.count;
	    sprintf ( myRet, "%s|xfs_count=%ld",myRet, xfs_count );
	    WORD  font        = pWB->xfs.xf[cell_xf].font       ; sprintf ( myRet, "%s|font=%d"       ,myRet, font        );
	    WORD  format      = pWB->xfs.xf[cell_xf].format     ; sprintf ( myRet, "%s|format=%d"     ,myRet, format      );
	    WORD  type        = pWB->xfs.xf[cell_xf].type       ; sprintf ( myRet, "%s|type=%d"       ,myRet, type        );
	    BYTE  align       = pWB->xfs.xf[cell_xf].align      ; sprintf ( myRet, "%s|align=%d"      ,myRet, align       );
	    BYTE  rotation    = pWB->xfs.xf[cell_xf].rotation   ; sprintf ( myRet, "%s|rotation=%d"   ,myRet, rotation    );
	    BYTE  ident       = pWB->xfs.xf[cell_xf].ident      ; sprintf ( myRet, "%s|ident=%d"      ,myRet, ident       );
	    BYTE  usedattr    = pWB->xfs.xf[cell_xf].usedattr   ; sprintf ( myRet, "%s|usedattr=%d"   ,myRet, usedattr    );
	    DWORD linestyle   = pWB->xfs.xf[cell_xf].linestyle  ; sprintf ( myRet, "%s|linestyle=%d"  ,myRet, linestyle   );
	    DWORD linecolor   = pWB->xfs.xf[cell_xf].linecolor  ; sprintf ( myRet, "%s|linecolor=%d"  ,myRet, linecolor   );
	    WORD  groundcolor = pWB->xfs.xf[cell_xf].groundcolor; sprintf ( myRet, "%s|groundcolor=%d",myRet, groundcolor );
	    printf ("%s\n", myRet );
	    myRet[0] = 0;
#endif

	//xls::st_format::st_format_data format_data;
struct st_format::st_format_data format_data;
	long formats_count = pWB->formats.count;
	    for ( long fc = 0; fc < formats_count; fc++ ) {
		if ( pWB->formats.format[fc].index == pWB->xfs.xf[cell_xf].format ) {
		    format_data = pWB->formats.format[fc];
		}
	    }

	    //printf ( "format_data.index=%d format_data.value=%p\n", format_data.index, format_data.value );
	    //printf ( "row->cells.cell[loop - 1].id=0x%x\n", row->cells.cell[loop - 1].id );
#ifdef DEBUG
	    printf ( "row->cells.cell[loop - 1].str=~%s~\n", row->cells.cell[loop - 1].str );
#endif
	//format data
	    if     ( 0x27e == row->cells.cell[loop - 1].id
	          || 0x0BD == row->cells.cell[loop - 1].id
	          || 0x203 == row->cells.cell[loop - 1].id  ) {
PFLID
		if ( 0 == 1 ) {}
//		else if ( row->cells.cell[loop - 1].str ) {
//PFLID
//		    sprintf ( myRet, "%s%s", myRet, row->cells.cell[loop - 1].str );
//		    myRet[ strlen (myRet) - 3 ] = 0;
//		}
		else if ( 'H' == format_data.value[0] ) {//time
PFLID
		//2do if > 1
		long DaySec = row->cells.cell[loop - 1].d * 86400;
		long Hour   = DaySec / 3600;
		long Min  = ( DaySec - Hour * 3600 ) / 60;
		long Sec  = ( DaySec - Hour * 3600 - Min * 60 );
		    sprintf ( myRet, "%s%02ld:%02ld:%02ld", myRet, Hour, Min, Sec );
		}
		else {
PFLID
		    setlocale ( LC_ALL, "C" );
		    sprintf ( myRet, "%s%.15g", myRet, row->cells.cell[loop - 1].d);
		}
	    }
	    else if ( 0x06 == row->cells.cell[loop - 1].id ) {// formula
PFLID
		if ( 0 == row->cells.cell[loop - 1].l ) {     // its a number
PFLID
		    sprintf ( myRet, "%s%.15g", myRet, row->cells.cell[loop - 1].d);
		}
		else {
PFLID
		    sprintf ( myRet, "%s%s", myRet, "bug formula 2do" );
		    //2do if (!strcmp((char *)cell->str, "bool")) { // its boolean, and test cell->d
		    //2do OutputString((int) cell->d ? "true" : "false");
		    //2do }
		    //2do else if (!strcmp((char *)cell->str, "error")) {// formula is in error
		    //2do OutputString("*error*");
		    //2do }
		    //2do else {// ... cell->str is valid as the result of a string formula.
		    //2do OutputString((char *)cell->str);
		    //2do }
		}
	    }//else if ( 0x06 == row->cells.cell[loop - 1].id )
	    else {//string
PFLID
		if ( row->cells.cell[loop - 1].str ) {
PFLID
		    sprintf ( myRet, "%s%s", myRet, row->cells.cell[loop - 1].str );
		}
		else {
PFLID
		    sprintf ( myRet, "%s%s", myRet, "" ); //NULL
		    //2do IsNull = 1
		}
	    }
	//format data done

#ifdef DEBUG
	    printf ("myRet=~%s~\n", myRet );
#endif
	    return  myRet;

	}//if ( strcmp ( tb->FetchColumn->Name, myCol->Name ) == 0 )
    }//while ( _bnColumn	*myCol = tb->Columns[loop++] )

    //sprintf ( tb->Error, "%s @ %s[%d]\n", "Column not found", __PRETTY_FUNCTION__, __LINE__ );

    return NULL;

}//char	*tbColumn	( _bnTable *tb )


char *ExcelRead1_0_tbRecord	( _bnTable *tb ) {
PFLID

//fetch record, done in tbColumn via Fokus

    return tb->Error;

}//char	*tbRecord	( _bnTable *tb )


char *ExcelRead1_0_tbSQLBuild	( _bnTable *tb ) {
PFLID

    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support INSERT", __PRETTY_FUNCTION__, __LINE__ ); }break;
    	case UPDATE:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support UPDATE", __PRETTY_FUNCTION__, __LINE__ ); }break;
	case DELETE:{ sprintf ( tb->Error, "%s @ %s[%d]\n", "This Modul dont support DELETE", __PRETTY_FUNCTION__, __LINE__ ); }break;
    	case SHOW_TABLES:{}break;
    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char *ExcelRead1_0_coDEF	( _bnColumn *co ) {
PFLID

    //return DEF2COL ( co, (_DEF2COL *)&DEF2ExcelRead );//2do test it
    return NULL;

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
