//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#include <bncsql.h>
#include <stdio.h>
#include <stdlib.h>

#include <bnBlob.h>

//#define bncSQL_DEBUG
#include <albus_log.h>
#ifndef bncSQL_DEBUG
# undef  MI
# define MI
# undef  D8
# define D8
# undef  D9
# define D9
#endif


char  Error[10000] = "";


void *bncSQLCmd ( void *bncSQLCmdArg ) {
    D8 ( "call" );

_bnBlob StdInSQLbl;
#define StdInSQLLen 1024
char    StdInSQL[StdInSQLLen];
    while ( unsigned long freadLen = fread ( StdInSQL, 1, StdInSQLLen - 1, stdin ) ) {
	StdInSQL[freadLen] = 0;
	StdInSQLbl.Append ( StdInSQL );
    }
    //StdInSQLbl.ShowString ( "/tmp/StdInSQLbl" ); //bug4debug
    //StdInSQLbl.FileWrite  ( "/tmp/StdInSQLbl" ); //bug4debug
    //MI ( "" );
    dbDefault.Show ();

_bncTable bncTable;
    bncTable.Querys ( (char *)StdInSQLbl.data );
    SIER ( bncTable.Error );//2do mssql, Error is not correct set

    //dbDefault.Destructor ();//bug4debug
    //MI ( "" );
    return NULL;

}//void *bncSQLCmd ( void *bncSQLCmdArg )


int main ( int argc, char **argv ) {

#ifdef bncSQL_DEBUG
    //albus_log_syslog = 1;                       //bug4debug
    //albus_log_level  = 9;                       //bug4debug
    //albus_log_stdio  = strdup ( "stderr"     ); //bug4debug
    //albus_log_file   = strdup ( "bncsql.log" ); //bug4debug
#endif

    Error[0] = 0;
    //printf ( "call argv[0]=~%s~\n", argv[0] );  //bug4debug
//ini DB
    dbDefault.Config ( argc, argv );

    D4 ( "NAME=~%s~ VERSION=~%s~ PREFIX=~%s~ PLATFORM=~%s~ BUILD_DATE_TIME=~%s~", PACKAGE_NAME, LIBBNCSQL_VERSION, PREFIX, PLATFORM, BUILD_DATE_TIME );

    MI ( "" );
    MI ( "" );
    bncSQLCmd ( NULL );
    MI ( "" );
    if ( Error[0] )  {
	fprintf ( stderr, "Error: %s\n", Error );
	return -1;
    }

    dbDefault.Destructor ();
    D8 ( "return 0" );
    return 0;

}//int main ( int argc, char **argv )
