//Copyright 2017-2018 blacknoise.at
//
//   Licensed under the Apache License, Version 2.0 (the "License");
//   you may not use this file except in compliance with the License.
//   You may obtain a copy of the License at
//
//       http://www.apache.org/licenses/LICENSE-2.0
//
//   Unless required by applicable law or agreed to in writing, software
//   distributed under the License is distributed on an "AS IS" BASIS,
//   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//   See the License for the specific language governing permissions and
//   limitations under the License.
//
#ifndef bncSQL
#define bncSQL

#define PACKAGE_NAME      "@PACKAGE_NAME@"
#define LIBBNCSQL_VERSION "@PACKAGE_VERSION@"
#define PACKAGE_BUGREPORT "@PACKAGE_BUGREPORT@"
#define PACKAGE_URL       "@PACKAGE_URL@"
#define TARGET_OS         "@TARGET_OS@"
#define TARGET_ARCH       "@TARGET_ARCH@"
#define PLATFORM          "@platform@"
#define PREFIX            "@prefix@"
#define BUILD_DATE_TIME   "@BUILD_DATE_TIME@"
#define UNIX_SEC          "@UNIX_SEC@"
#define TARGET            "@TARGET@"
//CPPFLAGS "@CPPFLAGS@"


//#define DEBUG
//#define bncSQL_DEBUG
//#define bncSQLRSync_DEBUG

#ifdef DEBUG
# define bncSQL_DEBUG
#endif

#ifndef HAVE_SSL
# undef HAVE_SSL
#endif

#ifndef bncSQLProxy_ENABLED
# undef bncSQLProxy_ENABLED
#endif

#ifndef bncSQLRSync_ENABLED
# undef bncSQLRSync_ENABLED
#endif

#ifndef bnSSL_ENABLED
# undef bnSSL_ENABLED
#endif

#ifndef bncSQL_DEBUG
# undef bncSQL_DEBUG
#endif

#include <stdlib.h>
#ifdef __APPLE__
# include <malloc/malloc.h>
#else
# include <malloc.h>
#endif

#define bncSQL_API_VERSION 0x01

#define bn_free(a) {\
    if (a) { free(a); }\
        a = NULL;\
}

#include <bncSQLColumn.h>
#include <bncSQLDataBase.h>
#include <bncSQLTable.h>

extern _bncDataBase  dbDefault;

#endif
