//delete itTablE;//seg fault if too many loops here via same cursor @ informix
//#define DEBUG
//#define ACTION

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define CRLF "<BR>\n"
#include <bnMakro.h>
#include <bnMemInfo.h>

#include <sqlca.h>
#include <sqlhdr.h>

#include "bnSQL.h"
#include "bnString.h"
#include "DEFInformix.h"

#define CursorArrayMAX	200


class	_TypeX {
public:
    long	 Type[255];
    long	 Size[255];
};


static	_SQCURSOR	 CEMPTY;
static	_SQCURSOR	 CursorArrayX[CursorArrayMAX];
_SQCURSOR		*CursorArrayP[CursorArrayMAX];
static	long		 CursorTables[CursorArrayMAX];
static	struct	sqlda	*udesc[CursorArrayMAX];
static	struct	_TypeX	 TypeX[CursorArrayMAX];

class	_InfRes {
public:
    long	OldFokus;	//2do 2 CursorArray
    int		infINS_UPD_DEL; //2do 2 CursorArray
};


extern "C" {

//functions from informix
    //OK    static char *sqlcmdtxt[] = { (char *) 0,(char *) 0 };
    //OK	sqlcmdtxt[0] = tb->SQLQuery;
    //OK    int	fgl_init	( int, char ** );
    //OK    int	fgl_siginit	( void );
    //OK    int _iqdclcur	( _SQCURSOR *, char *, char **, int, char *, int, char *, int );
    //	    int	fgl_fatal	( char *, int, int );
    //	    int	is8bitstr	( void );
    int	_iqdatabase	( char*, int, int, char * );
    int	_iqprepare	( _SQCURSOR *, char * );
    int _iqdscribe	( _SQCURSOR *, sqlda **	);
    int	_iqddclcur	( _SQCURSOR *, char *, int );
    int _iqcopen	( _SQCURSOR *, int, char *, char *, char *, int );
    int _iqnftch	( _SQCURSOR *, int, sqlvar_struct *, sqlda *, int, long, int, char *, char *, int );
    int	_iqstmnt	( _SQSTMT *, char **, int, char *, char *);
    int	_iqflush	( _SQCURSOR * );
    int	_iqclose	( _SQCURSOR * );
    int	_sqfreecursor	( _SQCURSOR * );
    int	_iqfree		( _SQCURSOR * );
    int	_autofree	( int );
    int	_efemode	( void );

//functions local
    char	*Informix5_10_tbRecordCount	( _bnTable *tb		);
    char	*DEF2COL	( _bnColumn  *co, _DEF2COL *DEG2Global );
    _bnColumn	*coInsertX	( _bnTable *tb, _DEF2COL *DEF2Global, char *Name, long Type, long Size, long Flags );


int	cryptX	( void ) { return 0; }


long	CursorNew ( long cnPos ) {
PFLID
    if ( ! CursorArrayP[cnPos] ) {
	CursorArrayP[cnPos] = &CursorArrayX[cnPos];
    //2do _SQCURSOR *nCur = new _SQCURSOR; CursorArrayP[cnPos] = nCur;
    }
    return 0;
}//long	CursorNew ( long cnPos )


long	CursorFree ( long cdPos ) {
PFLID

    memcpy ( CursorArrayP[cdPos], &CEMPTY, sizeof ( _SQCURSOR ) );
    return 0;
}//long	CursorFree ( long cfPos )


long	CursorGet ( _bnTable *tb ) {
PFLID

    for ( long cgLoop = 0; cgLoop <= CursorArrayMAX - 1; cgLoop++ )
	if      ( CursorTables[cgLoop] == 0 ) {
	    CursorTables[cgLoop] = (long)tb;
	    CursorNew ( cgLoop );
	    return cgLoop;
	}//if ( CursorTables[cgLoop] == 0 )
	else if ( CursorTables[cgLoop] == (long)tb ) {
	    CursorNew ( cgLoop );
	    return cgLoop;
	}

    sprintf ( tb->Error, "%s @ %s[%d]\n", "No Cursor Free", __PRETTY_FUNCTION__, __LINE__ );
    return -1;

}//long	CursorGet ( _bnTable *tb )


char 	*Informix5_10_dbOpen ( _bnDataBase *db ) {
PFLID

//error check
    if ( db->Error[0] )	return db->Error;

//inf Defaults
    db->Quote	= ' ';

//login 2 database
    if ( ! db->Conn ) {
#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%x"	, db				);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	printf ( "\n" );
	fflush  ( stdout );
#endif
    //login 2 database
	//2do su 2 db->User

    //IniInf Version:	3.0.0.6
	setenv ( "INFORMIXDIR"	,"/usr/local/inf5.10"	, 1 );
	setenv ( "DBDATE"	,"DMY4."		, 1 );
	setenv ( "DBEDIT"	,"vi"			, 1 );
	setenv ( "DBMONEY"	,".OS"			, 1 );
	setenv ( "DBPRINT"	,"/bin/lp"		, 1 );
	//#DBDELIMITER=\|
	setenv ( "DBFORMAT"	,":,:.:"		, 1 );
	setenv ( "DBPATH"	, db->Host		, 1 );
    char	dbTemp[255];
	sprintf ( dbTemp, "%s/tmp", db->Host );
	setenv ( "DBTEMP"	, dbTemp		, 1 );
	//2do TZ='CET-1CETDST,M3.5.0/1,M10.5.0/1'

    //open DataBase via dbName
	_iqdatabase( db->Base, 0, 0, (char *) 0 );
	if (sqlca.sqlcode < 0) {
	    sprintf ( db->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	    return db->Error;
	}

    //ini CursorTables
	for ( long cgLoop = 0; cgLoop <= 31; cgLoop++ )
	    CursorTables[cgLoop] = 0;
	db->Conn = db->Error;	//dummy vector

    }//if ( ! db->Conn )
    //login 2 database done

//all OK
    return db->Error;

}//char 	*dbOpen ( _bnDataBase *db )


char	*Informix5_10_dbClose ( _bnDataBase *db ) {
PFLID

//close aktiv conn
    if ( db->Conn ) {
#ifdef ACTION
	printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
	printf ( "	%s"	, (char *)__FILE__		);
	printf ( "	%s"	, db->Base			);
	printf ( "@%s"		, db->Host			);
	printf ( "\n" );
	fflush  ( stdout );
#endif
    //close aktiv conn
	_efemode();
	_autofree(0);

	db->Conn = NULL;

    }//if ( db->Conn )
//close aktiv conn done

//clean up
    return db->Error;

}//char	*dbClose ( _bnDataBase *db )


char	*Informix5_10_SQLCAShow	( void ) {
#ifndef DEBUG
    return NULL;
#endif
PFL

printf ( "sqlca=%x%s"	, (unsigned int)&sqlca, CRLF );
printf ( "long sqlca.sqlcode=%ld%s"	, sqlca.sqlcode		, CRLF );
printf ( "char sqlca.sqlerrm=%s%s"	, sqlca.sqlerrm		, CRLF ); // error message parameters
printf ( "char sqlca.sqlerrp=%s%s"	, sqlca.sqlerrp		, CRLF );
printf ( "long sqlca.sqlerrd[0]=%ld - estimated number of rows returned%s"		, sqlca.sqlerrd[0]	, CRLF );// 0 - estimated number of rows returned
printf ( "long sqlca.sqlerrd[1]=%ld - serial value after insert or  ISAM error code%s"	, sqlca.sqlerrd[1]	, CRLF );// 1 - serial value after insert or  ISAM error code
printf ( "long sqlca.sqlerrd[2]=%ld - number of rows processed%s"			, sqlca.sqlerrd[2]	, CRLF );// 2 - number of rows processed
printf ( "long sqlca.sqlerrd[3]=%ld - estimated cost%s"					, sqlca.sqlerrd[3]	, CRLF );// 3 - estimated cost
printf ( "long sqlca.sqlerrd[4]=%ld - offset of the error into the SQL statement%s"	, sqlca.sqlerrd[4]	, CRLF );// 4 - offset of the error into the SQL statement
printf ( "long sqlca.sqlerrd[5]=%ld - rowid after insert%s"				, sqlca.sqlerrd[5]	, CRLF );// 5 - rowid after insert

/*
struct sqlca_s
    {
    long sqlcode;
    char sqlerrm[72]; // error message parameters
    char sqlerrp[8];
    long sqlerrd[6];
		    // 0 - estimated number of rows returned
		    // 1 - serial value after insert or  ISAM error code
		    // 2 - number of rows processed
		    // 3 - estimated cost
		    // 4 - offset of the error into the SQL statement
		    // 5 - rowid after insert
    struct sqlcaw_s
	{
	char sqlwarn0; // = W if any of sqlwarn[1-7] = W
	char sqlwarn1; // = W if any truncation occurred or
			//	database has transactions
	char sqlwarn2; // = W if a null value returned or
			//	ANSI database
	char sqlwarn3; // = W if no. in select list != no. in into list or
			//	turbo backend
	char sqlwarn4; // = W if no where clause on prepared update, delete or
			//	incompatible float format
	char sqlwarn5; // = W if non-ANSI statement
	char sqlwarn6; // reserved
	char sqlwarn7; // reserved
	} sqlwarn;
    };
*/
    return NULL;
}//


char	*Informix5_10_tbCursorShow	( _bnTable *tb ) {
#ifndef DEBUG
    return tb->Error;
#endif
PFLID
    long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;
_SQCURSOR	*xCur = CursorArrayP[CursorNumber];

printf ( "short _SQCstmttype=%d%s"	, xCur->_SQCstmttype, CRLF );			// SQ_SELECT, SQ_INSERT, etc. 
printf ( "short _SQCsqlid=%d%s"		, xCur->_SQCsqlid, CRLF );			// SQL's id for this cursor
printf ( "short _SQCflags=%d%s"		, xCur->_SQCflags, CRLF );			// CROPEN, CREOF, CRSINGLE ,CRPREPARE
printf ( "short _SQCnfields=%d%s"	, xCur->_SQCnfields, CRLF );			// number of result fields
printf ( "short _SQCnibind=%d%s"	, xCur->_SQCnibind, CRLF );			// number of input args
printf ( "short _SQCnobind=%d%s"	, xCur->_SQCnobind, CRLF );			// number of output args
printf ( "short _SQCtcount=%d%s"	, xCur->_SQCtcount, CRLF );			// tuples remaining in buffer
printf ( "short _SQCtsize=%d%s"		, xCur->_SQCtsize, CRLF );			// length of data expected from
printf ( "short _SQCtbsize=%d%s"	, xCur->_SQCtbsize, CRLF );			// tuple buffer size
//printf ( "struct sqlvar_struct *_SQCibind	struct sqlvar_struct *_SQCibind, CRLF );	// pointer to first in array of 
//printf ( "struct sqlvar_struct *_SQCobind	struct sqlvar_struct *_SQCobind, CRLF );	// pointer to first in array of
printf ( "char **_SQCcommand=%s%s"	, (char *)(xCur->_SQCcommand), CRLF );			// pointer to ptrs to pieces of
//printf ( "struct sqlvar_struct *_SQCfields, CRLF );	// pointer to first in array of
printf ( "char *_SQCstrtab=%s%s"	, xCur->_SQCstrtab, CRLF );			// pointer to table of strings - the
printf ( "char *_SQCtbuf=%s%s"		, xCur->_SQCtbuf, CRLF );			// tuple buffer
printf ( "char *_SQCtuple=%s%s"		, xCur->_SQCtuple, CRLF );			// pointer to current tuple within
printf ( "char *_SQCname=%s%s"		, xCur->_SQCname, CRLF );			// cursor name
//printf ( "struct sqlda  *_SQCsqlda, CRLF );		// pointer to sqlda
printf ( "long _SQCfirst=%ld%s"		, xCur->_SQCfirst, CRLF );			// rowid of 1st tuple in buffer
printf ( "long _SQClast=%ld%s"		, xCur->_SQClast, CRLF );			// rowid of last tuple in buffer
printf ( "char *_SQCtable=%s%s"		, xCur->_SQCtable, CRLF );			// table name
//printf ( "char **_SQCselect_list, CRLF );		// selection/insert list
//printf ( "char **_SQCorderby_list, CRLF );		// order by list
//printf ( "_SQULIST _SQCulist, CRLF );			// the first power update list

/*
typedef struct 
    {
    short _SQCstmttype;			// SQ_SELECT, SQ_INSERT, etc. 
    short _SQCsqlid;			// SQL's id for this cursor
    short _SQCflags;			// CROPEN, CREOF, CRSINGLE ,CRPREPARE
    short _SQCnfields;			// number of result fields
					// (number supplied by SQL)
					//
    short _SQCnibind;			// number of input args
    short _SQCnobind;			// number of output args
    short _SQCtcount;			// tuples remaining in buffer
    short _SQCtsize;			// length of data expected from
					// SQL
					//
    short _SQCtbsize;			// tuple buffer size
    struct sqlvar_struct *_SQCibind;	// pointer to first in array of 
					// binding structures for arguments
					// to be taken from the user
					// program and sent to SQL;
					//
    struct sqlvar_struct *_SQCobind;	// pointer to first in array of
					// binding structures for values
					// to be received from SQL and
					// supplied to the user program;
					//
    char **_SQCcommand;			// pointer to ptrs to pieces of
					// the command 
					//
    struct sqlvar_struct *_SQCfields;	// pointer to first in array of
					// structures describing the data
					// to be received from SQL;
					// (fields described by SQL)
					//
    char *_SQCstrtab;			// pointer to table of strings - the
					// names of the attributes to be
					// received from SQL
					// (table supplied by SQL)
					//
    char *_SQCtbuf;			// tuple buffer
    char *_SQCtuple;			// pointer to current tuple within
					// buffer
					//
    char *_SQCname;			// cursor name
    struct sqlda  *_SQCsqlda;		// pointer to sqlda

		// used for scroll cursors
    long _SQCfirst;			// rowid of 1st tuple in buffer
    long _SQClast;			// rowid of last tuple in buffer

    // used by POWER CURSORS
    char *_SQCtable;			// table name
    char **_SQCselect_list;		// selection/insert list
    char **_SQCorderby_list;		// order by list
    _SQULIST _SQCulist;			// the first power update list
    // end of used by POWER CURSORS
    } _SQCURSOR;
*/
    return tb->Error;

}//char	*tbCursorShow	( _bnTable *tb )


char	*Informix5_10_tbColumnStack		( _bnTable *tb ) {
PFLID

long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;
int i;
struct sqlvar_struct *col;
    for (col = udesc[CursorNumber]->sqlvar, i = 0; i < udesc[CursorNumber]->sqld; col++, i++) {

    //save befor overwrite
	TypeX[CursorNumber].Type[i] = col->sqltype;
	TypeX[CursorNumber].Size[i] = col->sqllen;

	col->sqltype	= 100;			//char	//2do dont overwrite
	col->sqllen	= 512;			//size	//2do dont overwrite
	col->sqldata	= (char  *)malloc( col->sqllen + 1 );//2do free
	col->sqlind	= (short *) 0;		// pointer to indicator
    	//col->sqlname	= (char  *) 0;		// variable name
    	col->sqlformat	= (char  *) 0;		// reserved for future use
    	col->sqlitype	= 0;			// ind variable type
    	col->sqlilen	= 0;			// ind length in bytes
    	col->sqlidata	= (char  *) 0;		// ind data pointer

    }//for ( int tb_FieldFokus = 0; tb_FieldFokus < tb->Fields; tb_FieldFokus++ )
//    bnMemInfo ( (char *)__PRETTY_FUNCTION__, __LINE__ );
    return tb->Error;

}//char	*tbColumnStack		( _bnTable *tb )


_bnColumn	*Informix5_10_tbColumnInsert	( _bnTable *tb ) {
PFLID

long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return NULL;
int i;
struct sqlvar_struct *col;
    for (col = udesc[CursorNumber]->sqlvar, i = 0; i < udesc[CursorNumber]->sqld; col++, i++)
	if ( i == tb->ColumnInsertFokus ) {
	char	*myName  = col->sqlname;
	long	 myType  = TypeX[CursorNumber].Type[i];
	long	 mySize  = TypeX[CursorNumber].Size[i];
	long	 myFlags = 0;
	    return    coInsertX	( tb, (_DEF2COL *)&Informix2DEF, myName, myType, mySize, myFlags );
	}//if ( i == tb->ColumnInsertFokus )

    return NULL;

}//_bnColumn	*Informix5_10_tbColumnInsert	( _bnTable *tb )


char	*tbSetSerial ( _bnTable *tb ) {
PFLID

char	*Error = tb->Error;
char	xStay = 0;
    if ( strncmp ( tb->SQLQuery, "INSERT", 6 ) == 0 ) xStay = 1;
    if ( strncmp ( tb->SQLQuery, "insert", 6 ) == 0 ) xStay = 1;
    if ( ! xStay ) return Error;

    long tsPos = 0;
    _bnColumn	*coFirstSerial = NULL;
    while ( _bnColumn	*tsCol = (_bnColumn	*)(*tb)[tsPos++] ) {
	if ( strcmp ( tsCol->Type, "serial" ) == 0 ) {
	    if ( ! coFirstSerial ) coFirstSerial = tsCol;
	    else SER ("double coFirstSerial found");
	}
    }

    if ( ! coFirstSerial ) return Error;//out @ 7.6.0.182 SER ( "! coFirstSerial" );
    //Informix5_10_SQLCAShow ();

long	   InsSerial = sqlca.sqlerrd[1];
    if ( InsSerial <= 0 ) SER ( "InsSerial <= 0" );

long	 *coSerial = coFirstSerial->GetLong ();
    if ( *coSerial ) SER ( "*coSerial" );

    *coSerial = InsSerial;

    return Error;

}//char	*tbSetSerial ( _bnTable *tb )


char	*Informix5_10_tbOpen		( _bnTable *tb ) {
PFLID

//error check
	 if ( ! tb->SQLQuery    ) strcpy ( tb->Error, "SQLQuery = NULL"  );
    else if ( ! tb->SQLQuery[0] ) strcpy ( tb->Error, "SQLQuery = empty" );
    if ( tb->Error[0] ) return tb->Error;

//CursorNumber
    long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;

    if ( tb->Result ) return tb->Error;
#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__		);
    printf ( "	%x"		, tb				);
    printf ( "	%s"		, tb->Name			);
    printf ( "%s", CRLF );
    printf ( "SQL=~%s~%s"	, tb->SQLQuery, CRLF );
    printf ( "Cursor=%ld%s"	, CursorNumber, CRLF );
#endif

    tb->Result	 = (_InfRes *)new _InfRes;
    if ( ! tb->Result ) {
	strcpy ( tb->Error, "! tb->Result" );
	return tb->Error;
    }

    ((_InfRes *)tb->Result)->infINS_UPD_DEL = 0;
    if ( strncmp ( tb->SQLQuery, "UPDATE", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "update", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "DELETE", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "delete", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "INSERT", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "insert", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "CREATE", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;
    if ( strncmp ( tb->SQLQuery, "create", 6 ) == 0 ) ((_InfRes *)tb->Result)->infINS_UPD_DEL = 1;

    _iqprepare( CursorArrayP[CursorNumber], tb->SQLQuery );//seg fault if too many loops here @ same cursor
    if (sqlca.sqlcode < 0) {
	sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	return tb->Error;
    }

    _iqdscribe( CursorArrayP[CursorNumber], &udesc[CursorNumber]);
    if (sqlca.sqlcode < 0) {
	sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	return tb->Error;
    }

    Informix5_10_tbColumnStack		( tb );

char	cName[255];
    sprintf ( cName, "A%X", (unsigned int)tb );
    _iqddclcur( CursorArrayP[CursorNumber], cName, 4128);	//2do	? 4128
    if (sqlca.sqlcode < 0) {
	sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	return tb->Error;
    }

//insert, update, del
    if ( ((_InfRes *)tb->Result)->infINS_UPD_DEL ) {
    static _SQSTMT _SQ0 = {0};
    static char *sqlcmdtxt[] = { (char *) 0,(char *) 0 };
        sqlcmdtxt[0] = tb->SQLQuery;
	_iqstmnt(&_SQ0, sqlcmdtxt, 0, (char *) 0, (char *) 0);
	if ( sqlca.sqlcode < 0 ) {
	    sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	    return tb->Error;
	}
	tbSetSerial ( tb );
    }//if ( infINS_UPD_DEL )
//select ...
    else {
	_iqcopen  ( CursorArrayP[CursorNumber],   0, (char *) 0, (char *) 0, (char *) 0,   0 );
	if ( sqlca.sqlcode < 0 ) {
	    sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	    return tb->Error;
	}
    }//else if ( infINS_UPD_DEL )

//error check
    if ( tb->Error[0] ) return tb->Error;

//amount of Records
    tb->Records	= 0;
    tb->Fokus	= 0;
    ((_InfRes *)tb->Result)->OldFokus	= 0;
    tb->Fields	= 0;						//2do count above

    if ( ! ((_InfRes *)tb->Result)->infINS_UPD_DEL )
	while ( Informix5_10_tbRecordCount ( tb ) ) tb->Records++;//2do optimize speed

//amount of Fields
    tb->Fields  = (*CursorArrayP)[CursorNumber]._SQCnfields;	//2do count above

#ifdef ACTION
    printf ( "Fields=%04ld Records=%010ld\n", tb->Fields, tb->Records );	fflush  ( stdout );
#endif

    Informix5_10_tbCursorShow	( tb );

    return tb->Error;

}//char	*tbOpen		( _bnTable *tb )



char	*Informix5_10_tbClose	( _bnTable *tb ) {
PFLID

    if ( ! tb->Result ) return tb->Error;

    //Informix5_10_tbCursorShow	( tb );

long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;

int i;
struct sqlvar_struct *col;

    for (col = udesc[CursorNumber]->sqlvar, i = 0; i < udesc[CursorNumber]->sqld; col++, i++)
	free ( col->sqldata );

#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "	%s"		, (char *)__FILE__		);
    printf ( "	%x"		, tb				);
    printf ( "	%s"		, tb->Name			);
    printf ( "\n" );
    printf ( "Cursor=%ld\n"	, CursorNumber			);
#endif

//close table
    //_iqflush ( &CursorArray[CursorNumber] );//only @ insert ?!
    if ( ! ((_InfRes *)tb->Result)->infINS_UPD_DEL ) {
	_iqclose ( CursorArrayP[CursorNumber] );
	if (sqlca.sqlcode < 0) {
	    sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	    return tb->Error;
	}
    }//if ( ! ((_InfRes *)tb->Result)->infINS_UPD_DEL )

    _iqfree ( CursorArrayP[CursorNumber] );

//_SQCURSOR	*xCur = CursorArrayP[CursorNumber];
//_SQCURSOR	*cNew = new _SQCURSOR;
//printf ( "sizeof ( _SQCURSOR )=%ld<br>", sizeof ( _SQCURSOR ) );
//	memcpy ( (void *)xCur, cNew, sizeof ( _SQCURSOR ) );

    CursorFree ( CursorNumber );

    //Informix5_10_tbCursorShow	( tb );


    delete (_InfRes *)tb->Result;
    tb->Result = NULL;
char	*Error = tb->Error;

//all OK
    return Error;

}//char	*tbClose	( _bnTable *tb )


char	*Informix5_10_tbRecordCount		( _bnTable *tb ) {
PFLID

    long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;

//fetch in data
int _iqnftch_SEEK = 1;	//next	default
    _iqnftch   ( CursorArrayP[CursorNumber],          0,            NULL,              udesc[CursorNumber], _iqnftch_SEEK, (long) 0,   0, (char *) 0, (char *) 0,   0 );
    if (sqlca.sqlcode < 0) {
	sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	return NULL;
    }

//last rec reached
    if ( sqlca.sqlcode == 100 ) return NULL;

    return (char *)tb;

}//char	*tbRecordCount	( _bnTable *tb )


char	*Informix5_10_tbRecord		( _bnTable *tb ) {
PFLID

    long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;

//no action
    if ( tb->Error[0] ) return tb->Error;

#ifdef ACTION
    printf ( "%s"		, (char *)__PRETTY_FUNCTION__	);
    printf ( "		%s"	, (char *)__FILE__		);
    printf ( "	%x"	, tb				);
    printf ( "	%s"	, tb->Name			);
    printf ( "\n" );
    fflush  ( stdout );
#endif

//SEEK in _iqnftch
int _iqnftch_SEEK;						_iqnftch_SEEK = 1;	//next	default
    if      ( tb->Fokus ==           0 )			_iqnftch_SEEK = 1;	//next via tbOpen
    else if ( tb->Fokus ==           1 )			_iqnftch_SEEK = 3;	//first
    else if ( tb->Fokus == tb->Records )			_iqnftch_SEEK = 4;	//last
    if	( tb->Fokus < ((_InfRes *)tb->Result)->OldFokus )	_iqnftch_SEEK = 2;	//prev
    ((_InfRes *)tb->Result)->OldFokus = tb->Fokus;


//clean up last in data
int i;
struct sqlvar_struct *col;
    for (col = udesc[CursorNumber]->sqlvar, i = 0; i < udesc[CursorNumber]->sqld; col++, i++) {
	//printf ( "col->sqlname = %s\n"  , col->sqlname );
	//printf ( "col->sqldata = ~%s~\n", col->sqldata );
	//printf ( "col->sqldata = %p\n"  , col->sqldata );
	//printf ( "col->sqllen  =  %ld\n", col->sqllen  );
	//printf ( "TypeX[CursorNumber].Size[i] = %ld\n", TypeX[CursorNumber].Size[i] );
	//printf ( "TypeX[CursorNumber].Type[i] = %ld\n", TypeX[CursorNumber].Type[i] );
	memset ( col->sqldata, 0x00, col->sqllen );
    }

//fetch in data
    _iqnftch   ( CursorArrayP[CursorNumber],          0,            NULL,              udesc[CursorNumber], _iqnftch_SEEK, (long) 0,   0, (char *) 0, (char *) 0,   0 );
    if (sqlca.sqlcode < 0) {
	sprintf ( tb->Error, "%ld @ %s[%d]\n", sqlca.sqlcode, __PRETTY_FUNCTION__, __LINE__ );
	return tb->Error;
    }

//last rec reached
    if ( sqlca.sqlcode == 100 ) return tb->Error;

    return tb->Error;

}//char	*Informix5_10_tbRecord		( _bnTable *tb )


char	*Informix5_10_tbColumn		( _bnTable *tb ) {
PFLID
    //Informix5_10_tbCursorShow	( tb );
    long CursorNumber = CursorGet ( tb ); if ( tb->Error[0] ) return tb->Error;

//lowercase
char lowerName[255];
    strcpy ( lowerName, tb->FetchColumn->Name );
    for ( unsigned int sPos = 0; sPos < strlen ( lowerName ); sPos++ )
	lowerName[sPos] = tolower ( lowerName[sPos] );

int i;
struct sqlvar_struct *col;
    for (col = udesc[CursorNumber]->sqlvar, i = 0; i < udesc[CursorNumber]->sqld; col++, i++)
	if ( strcmp ( lowerName, col->sqlname ) == 0 ) {
	    switch ( col->sqltype ) {
		//case    0:	//bnCHAR[x]	char()
		//case    1:	//bnLONG	smallint
		//case    2:	//bnLONG	integer
		//case    6:	//bnLONG	serial
		//case    5:	//bnDOUBLE	decimal(x,y)
		//case    8:	//bnCHAR[30]	money(x,y)
		//case    7:	//bnCHAR[30	date
		//case   10:	//bnCHAR[30	datetime year to fraction(3)
		case    100:	//bnCHAR[x]	char()
		    StrDropPost	( col->sqldata, 0x20 );
		    return col->sqldata;
		    break;

		default:
		    sprintf ( tb->Error, "%s @ %s[%d]\n", "unknown col->sqltype", __PRETTY_FUNCTION__, __LINE__ );
		    return NULL;
		    break;

	    }//switch ( col->sqltype )
	}//if ( strcmp ( lowerName, col->sqlname ) == 0 )

    return NULL;

}//char	*tbColumn		( _bnTable *tb )


char	*Informix5_10_tbSQLBuild	( _bnTable *tb ) {
PFLID

    switch ( tb->SQLBuildMode ) {
    	case SELECT:{}break;
    	case INSERT:{}break;
    	case UPDATE:{}break;
	case DELETE:{}break;
	case CREATE_TABLE:
	    if ( strcmp ( tb->SQLBuild_SQLQuery, "create temporary table" ) == 0 )
		strcpy ( tb->SQLBuild_SQLQuery, "create temp table" );
	    break;
    	case SHOW_TABLES:
	    sprintf ( tb->SQLBuild_SQLQuery, "select tabname as name from systables where tabid>=100 order by tabname" );
	    break;
    }//switch ( tb->SQLBuildMode )

    return tb->Error;

}//char	*tbSQLBuild	( _bnTable *tb )


char	*Informix5_10_coDEF	( _bnColumn *co ) {
PFLID

    return DEF2COL ( co, (_DEF2COL *)&DEF2Informix );

}//char	*coDEF	( _bnTable *tb )

}//extern "C"
